package sexpression;

public class LispNumber extends Atom {

    private int value;

    public LispNumber(String text) {
        super(text.replaceFirst("^0+(?!$)", ""));

        try {
            this.value = Integer.parseInt(text);
        } catch (NumberFormatException e) {
            throw new IllegalArgumentException(text + " is not a valid integer");
        }
    }

    public LispNumber(int value) {
        super(Integer.toString(value));

        this.value = value;
    }

    public boolean numberp() {
        return true;
    }

    public int getValue() {
        return value;
    }

}
