package sexpression;

public abstract class SExpression {

    // for mark and sweep garbage collection
    private boolean marked = false;

    public final boolean isMarked() {
        return marked;
    }

    public final void setMarked(final boolean value) {
        marked = value;
    }

    // Lisp type predicates...
    // overridden in subclasses to describe their Lisp type

    public boolean nullp() {
        return false;
    }

    public boolean atomp() {
        return false;
    }

    public boolean consp() {
        return false;
    }

    public boolean listp() {
        return (consp() || nullp());
    }

    public boolean numberp() {
        return false;
    }

    public boolean symbolp() {
        return false;
    }

    public boolean functionp() {
        return false;
    }

    public boolean stringp() {
        return false;
    }

}
